<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="等级" prop="level">
        <el-input-number v-model="formData.level" placeholder="请输入等级" :step="1" />
      </el-form-item>
      <el-form-item label="显示名称" prop="displayName">
        <el-input v-model="formData.displayName" placeholder="请输入显示名称" />
      </el-form-item>
      <el-form-item label="等级图标" prop="displayName">
        <UploadImg v-model="formData.levelIcon" />
      </el-form-item>
      <el-form-item label="每日任务数量" prop="taskLimit">
        <el-input v-model="formData.taskLimit" placeholder="请输入每日任务数量" />
      </el-form-item>
      <el-form-item label="每单佣金(%)" prop="commissionRate">
        <el-input v-model="formData.commissionRate" placeholder="请输入每单佣金(%)" />
      </el-form-item>
      <el-form-item label="最低提现金额" prop="minimumWithdrawalAmount">
        <el-input v-model="formData.minimumWithdrawalAmount" placeholder="请输入最低提现金额" />
      </el-form-item>
      <el-form-item label="充值额度" prop="price">
        <el-input v-model="formData.price" placeholder="请输入充值额度" />
      </el-form-item>
      <el-form-item label="团队人数" prop="teamMembers">
        <el-input v-model="formData.teamMembers" placeholder="请输入团队人数" />
      </el-form-item>
      <el-form-item label="有效人数" prop="activeTeamMembers">
        <el-input v-model="formData.activeTeamMembers" placeholder="请输入有效人数" />
      </el-form-item>
      <el-form-item label="描述">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as LevelConfigApi from '@/api/member/levelConfig'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  level: undefined,
  displayName: undefined,
  levelIcon: undefined,
  taskLimit: undefined,
  commissionRate: undefined,
  minimumWithdrawalAmount: undefined,
  price: undefined,
  teamMembers: undefined,
  activeTeamMembers: undefined,
  description: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await LevelConfigApi.getLevelConfig(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as LevelConfigApi.LevelConfigVO
    if (formType.value === 'create') {
      await LevelConfigApi.createLevelConfig(data)
      message.success(t('common.createSuccess'))
    } else {
      await LevelConfigApi.updateLevelConfig(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    level: undefined,
    displayName: undefined,
    taskLimit: undefined,
    commissionRate: undefined,
    minimumWithdrawalAmount: undefined,
    price: undefined,
    teamMembers: undefined,
    activeTeamMembers: undefined,
    description: undefined
  }
  formRef.value?.resetFields()
}
</script>
